VERSION 5.00
Object = "{0ECD9B60-23AA-11D0-B351-00A0C9055D8E}#6.0#0"; "MShflxgd.ocx"
Begin VB.UserControl ucMainGrid 
   BorderStyle     =   1  'Fest Einfach
   ClientHeight    =   5895
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   9600
   ScaleHeight     =   5895
   ScaleWidth      =   9600
   Begin VB.PictureBox picUpDown 
      AutoRedraw      =   -1  'True
      BackColor       =   &H00404040&
      BorderStyle     =   0  'Kein
      BeginProperty Font 
         Name            =   "Wingdings"
         Size            =   11.25
         Charset         =   2
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H0000FF00&
      Height          =   75
      Left            =   0
      ScaleHeight     =   5
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   11
      TabIndex        =   1
      Top             =   0
      Visible         =   0   'False
      Width           =   165
   End
   Begin MSHierarchicalFlexGridLib.MSHFlexGrid FG 
      Height          =   5445
      Left            =   360
      TabIndex        =   0
      Top             =   330
      Width           =   8655
      _ExtentX        =   15266
      _ExtentY        =   9604
      _Version        =   393216
      BackColor       =   16777215
      Rows            =   0
      FixedRows       =   0
      FixedCols       =   0
      BackColorFixed  =   4210752
      ForeColorFixed  =   33023
      BackColorSel    =   8454016
      ForeColorSel    =   0
      GridColor       =   14737632
      ScrollTrack     =   -1  'True
      SelectionMode   =   1
      AllowUserResizing=   1
      BorderStyle     =   0
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Arial"
         Size            =   9
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      _NumberOfBands  =   1
      _Band(0).Cols   =   2
   End
End
Attribute VB_Name = "ucMainGrid"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Event RowSelectionChanged(ByVal RecordID As Long, ByVal RowNr As Long)
Event FillFinished(ByVal RecordCount As Long, ByVal FillTime As String)
Event RightMouseClick()
Event ApplySorting(SortColumn As String, ByVal Desc As Boolean)
Event DblClick()

Public LastSQLString As String, LastRow As Long, LastTopRow As Long
Public LastSortCol As Long, bDescending As Boolean

Public HideIDColumn As Boolean

Private Sub UserControl_Resize()
  FG.Move 0, 0, ScaleWidth, ScaleHeight
End Sub

Public Property Get Flex() As MSHFlexGrid
  Set Flex = FG
End Property

Public Sub RefreshWith(Rs As Recordset, Optional ByVal ResetSorting As Boolean)
Dim T!: T = Timer
  If Rs.Source <> LastSQLString Then LastSQLString = Rs.Source: LastTopRow = 0
  If ResetSorting Then bDescending = False:  LastSortCol = 0
  
  DoEvents
  If LastSQLString <> Rs.Source Then Exit Sub
 
  FG.Redraw = False
    Set FG.DataSource = Nothing
    FG.Rows = 2: FG.FixedRows = 1
    
    If Rs.BOF Then
      FG.Rows = 1
      LastRow = 0
      LastTopRow = 0
    Else
      Set FG.DataSource = Rs
      If LastRow >= FG.Rows - 1 Then LastRow = FG.Rows - 1
      If LastTopRow >= FG.Rows - 1 Then LastTopRow = FG.Rows - 1
      If LastTopRow Then FG.Row = LastRow: FG.TopRow = LastTopRow Else FG.Row = 1: FG.TopRow = 1
    End If
        
    FG.Col = 0: FG.ColSel = FG.Cols - 1 'select the full row
    FG.RowHeight(0) = 345 '<-HeaderHeight
    FG.ColWidth(0) = IIf(HideIDColumn, 0, 1000)
    
    RaiseEvent FillFinished(FG.Rows - 1, Format(Timer - T, "0.000sec"))
    FG_EnterCell
    FG_SelChange
    ApplySorting
  FG.Redraw = True
End Sub

Public Sub SetCellValue(ByVal RowNr As Long, FieldName As String, FieldValue)
Dim i As Long
  For i = 0 To FG.Cols - 1
    If LCase(FG.TextMatrix(0, i)) = LCase(FieldName) Then Exit For
  Next i
  If i < FG.Cols Then FG.TextMatrix(RowNr, i) = FieldValue
End Sub

Public Function GetIDList() As String
Dim i As Long, j As Long, IDArr() As String
  If FG.Rows < 2 Then Exit Function
  ReDim IDArr(0 To Abs(FG.Row - FG.RowSel))
  For i = FG.Row To FG.RowSel Step IIf(FG.Row > FG.RowSel, -1, 1)
    IDArr(j) = FG.TextMatrix(i, 0): j = j + 1
  Next i
  GetIDList = Join(IDArr, ",")
End Function

Private Sub FG_EnterCell()
  FG.CellBackColor = &H80FFFF
End Sub
Private Sub FG_LeaveCell()
  FG.CellBackColor = vbWhite
End Sub
Private Sub FG_SelChange()
  LastRow = FG.Row
  LastTopRow = IIf(FG.Row, FG.TopRow, 0)
  Dim CurID As Long: CurID = IIf(FG.Row, Val(FG.TextMatrix(FG.Row, 0)), 0)
  If Not FG.DataSource Is Nothing Then
    Dim Rs As Recordset
    Set Rs = FG.DataSource
    If Rs.RecordCount Then Rs.AbsolutePosition = LastRow
  End If
  RaiseEvent RowSelectionChanged(CurID, LastRow)
End Sub
Private Sub FG_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
  If Button = vbRightButton Then RaiseEvent RightMouseClick
End Sub

Private Sub FG_DblClick()
  RaiseEvent DblClick
End Sub

Private Sub FG_Click()
  If FG.MouseRow <> 0 Then Exit Sub
  bDescending = Not bDescending
  LastSortCol = FG.MouseCol
  
  RaiseEvent ApplySorting(FG.TextMatrix(0, LastSortCol), bDescending)
  ApplySorting
End Sub
Private Sub ApplySorting()
Dim i&, mRowBuf As Long, mColBuf As Long
  FG.Redraw = False
    mRowBuf = FG.Row: mColBuf = FG.Col
 
      FG.Row = 0
      For i = 0 To FG.Cols - 1
        FG.Col = i: Set FG.CellPicture = Nothing
      Next i
      FG.Col = LastSortCol
      FG.CellPictureAlignment = flexAlignCenterTop

      picUpDown.Cls
      picUpDown.CurrentX = -1
      picUpDown.CurrentY = IIf(bDescending, -8, -1)
      picUpDown.Print IIf(bDescending, "", "")
      Set FG.CellPicture = picUpDown.Image
 
    FG.Row = mRowBuf: FG.Col = mColBuf: FG.ColSel = FG.Cols - 1
  FG.Redraw = True
End Sub

Public Sub SelectRow(Optional ByVal RowNr As Long = -1)
  If RowNr = -1 Then RowNr = FG.Rows - 1
  FG.TopRow = RowNr
  FG.SetFocus
  FG_LeaveCell
    FG.Row = RowNr
    FG.ColSel = FG.Cols - 1
  FG_EnterCell
  FG_SelChange
End Sub

