VERSION 5.00
Begin VB.Form fMain 
   BorderStyle     =   0  'None
   Caption         =   "Work Orders - Zone Home Entertainment"
   ClientHeight    =   4485
   ClientLeft      =   60
   ClientTop       =   -45
   ClientWidth     =   9765
   LinkTopic       =   "Form1"
   Moveable        =   0   'False
   ScaleHeight     =   299
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   651
   ShowInTaskbar   =   0   'False
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdRefresh 
      BackColor       =   &H00C0FFC0&
      Caption         =   "Refresh"
      Height          =   345
      Left            =   8370
      Style           =   1  'Graphical
      TabIndex        =   9
      Top             =   795
      Width           =   855
   End
   Begin VB.CommandButton cmdDeleteSel 
      BackColor       =   &H008080FF&
      Caption         =   "Delete Selected Group"
      Height          =   345
      Left            =   12720
      Style           =   1  'Graphical
      TabIndex        =   8
      Top             =   795
      Width           =   1845
   End
   Begin VB.CommandButton cmdAdd 
      BackColor       =   &H00C0FFFF&
      Caption         =   "Add New"
      Height          =   345
      Left            =   10290
      Style           =   1  'Graphical
      TabIndex        =   7
      Top             =   795
      Width           =   915
   End
   Begin VB.CommandButton cmdEdit 
      BackColor       =   &H0080FFFF&
      Caption         =   "Edit"
      Height          =   345
      Left            =   9510
      Style           =   1  'Graphical
      TabIndex        =   6
      Top             =   795
      Width           =   735
   End
   Begin VB.CommandButton cmdDelete 
      BackColor       =   &H00C0C0FF&
      Caption         =   "Delete Current"
      Height          =   345
      Left            =   11460
      Style           =   1  'Graphical
      TabIndex        =   5
      Top             =   795
      Width           =   1215
   End
   Begin VB.ComboBox cmbSearch 
      Height          =   315
      Left            =   1020
      Style           =   2  'Dropdown List
      TabIndex        =   3
      Top             =   810
      Width           =   2835
   End
   Begin VB.TextBox txtSearch 
      Height          =   330
      Left            =   5400
      TabIndex        =   1
      Top             =   810
      Width           =   2865
   End
   Begin ZHEWorkOrders.ucMainGrid MainGrid 
      Height          =   3000
      Left            =   120
      TabIndex        =   0
      Top             =   1290
      Width           =   9000
      _ExtentX        =   30824
      _ExtentY        =   14261
   End
   Begin VB.TextBox Text1 
      Height          =   285
      Left            =   6720
      TabIndex        =   11
      Text            =   "Text1"
      Top             =   2040
      Width           =   1575
   End
   Begin VB.Label Label3 
      Caption         =   "Work Orders"
      BeginProperty Font 
         Name            =   "Verdana"
         Size            =   20.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   5880
      TabIndex        =   10
      Top             =   0
      Width           =   3015
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Filter by:"
      Height          =   195
      Left            =   270
      TabIndex        =   4
      Top             =   870
      Width           =   735
   End
   Begin VB.Label Label2 
      AutoSize        =   -1  'True
      Caption         =   "Enter Search-Text:"
      Height          =   195
      Left            =   3960
      TabIndex        =   2
      Top             =   870
      Width           =   1515
   End
End
Attribute VB_Name = "fMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" _
 (ByVal hwnd As Long, _
  ByVal wMsg As Long, _
  ByVal wParam As Long, _
  lParam As Any) As Long


Private Declare Function SendMessageByString Lib "user32" Alias "SendMessageA" _
 (ByVal hwnd As Long, _
  ByVal wMsg As Long, _
  ByVal wParam As Long, _
  ByVal lParam As String) As Long

Private Const WM_SETTEXT = &HC
Private Const BM_CLICK = &HF5
Private Const WM_SETFOCUS = &H7

Private AllowClose As Boolean
 
Private Sub Form_Load()
Dim i As Long
  dbOpen
  fMain.MainGrid.RefreshWith RsMain, True

  For i = 1 To RsMain.Fields.Count - 1
    cmbSearch.AddItem RsMain.Fields(i).Name
  Next
  If cmbSearch.ListCount Then cmbSearch.ListIndex = 0
  
  Dim s As String
 Dim a() As String
 s = Command()     ' get handle of caller
 
 a = Split(s, ",") ' a(0) = My App number, a(1) = Caller App's Text1(n) handle
 
 SendMessageByString CLng(a(1)), WM_SETTEXT, 0, Me.hwnd & "," & Me.Text1.hwnd
 
 Show
 
End Sub

Private Sub cmdAdd_Click()
  frmEdit.InitAndShow
End Sub

Private Sub cmdEdit_Click()
  If RsMain.RecordCount Then
    frmEdit.InitAndShow RsMain(0).Value
  Else
    MsgBox "There are no records to modify or delete!", vbExclamation, "Error"
  End If
End Sub

Private Sub cmdDelete_Click()
  If RsMain.RecordCount Then
    MainGrid.SelectRow RsMain.AbsolutePosition
    If MsgBox("Are you sure you want to delete the selected record?", vbYesNo, "Delete") = vbNo Then Exit Sub
    
    RsMain.Delete
    RsMain.UpdateBatch
    MainGrid.RefreshWith RsMain
    
    MsgBox "The selected record was deleted", vbExclamation, "Delete"
  Else
    MsgBox "There are no records to modify or delete!", vbExclamation, "Error"
  End If
End Sub

Private Sub cmdDeleteSel_Click()
  If RsMain.RecordCount Then
    If MsgBox("Are you sure you want to delete all of the selected records?", vbYesNo, "Delete") = vbNo Then Exit Sub
    
    Conn.Execute "Delete From tbl_info Where id_info In (" & MainGrid.GetIDList & ")"
    cmdRefresh_Click
    
    MsgBox "The selected records were deleted", vbExclamation, "Delete"
  Else
    MsgBox "There are no records to modify or delete!", vbExclamation, "Error"
  End If
End Sub

Private Sub cmdRefresh_Click()
  RsMain.Requery
  MainGrid.RefreshWith RsMain
End Sub
 
Private Sub cmbSearch_Click()
  txtSearch_Change 'just re-trigger this way
End Sub

Private Sub Form_Resize()
  'MainGrid.Move 0, 1200, ScaleWidth, IIf(ScaleHeight - 1200 > 1, ScaleHeight - 1200, 1)
  MainGrid.Move 0, 80, ScaleWidth, ScaleHeight - 80
End Sub

Private Sub MainGrid_DblClick()
  cmdEdit_Click
End Sub

Private Sub txtSearch_Change()
  If Len(cmbSearch.Text) = 0 Then Exit Sub

  RsMain.Filter = IIf(Len(txtSearch.Text), "[" & cmbSearch.Text & "] Like '" & txtSearch.Text & "%'", "")

  fMain.MainGrid.RefreshWith RsMain
End Sub

Private Sub MainGrid_ApplySorting(SortColumn As String, ByVal Desc As Boolean)
Dim BookMark
  If RsMain.RecordCount = 0 Then Exit Sub
  
  BookMark = RsMain.BookMark
    RsMain.Sort = "[" & SortColumn & IIf(Desc, "] Desc", "]") 'we simply use a clientside sort within the RsMain-Container, not stressing the DB-engine
    MainGrid.RefreshWith RsMain
  RsMain.BookMark = BookMark
  
  MainGrid.SelectRow RsMain.AbsolutePosition
End Sub

Private Sub Text1_Change()
 ' Do not use MsgBox because it hides behind App and cannot be clicked.
 ' This will cause a locked situation
 Select Case Text1.Text
   Case "START"
     'MsgBox "START WAS DETECTED"
   Case "CLOSE"
     'MsgBox "CLOSE WAS DETECTED"
     AllowClose = True
     Unload Me
 End Select
End Sub

'Private Sub MainGrid_RowSelectionChanged(ByVal RecordID As Long, ByVal RowNr As Long)
  'just for debug-purposes, as an informal proof for the synchronous behaviour of the Grid-Index and the RsMain-RecordPointer
  'If RsMain.RecordCount Then fMain.Caption = RsMain.AbsolutePosition & " " & RecordID & " " & RowNr & " " & RsMain.Fields(0)
'End Sub
 
Private Sub Form_Unload(Cancel As Integer)
Cancel = Not AllowClose
Dim Form As Form
  For Each Form In Forms
    Unload Form
    DoEvents
  Next
End Sub
